#!/bin/sh -e

CON_NAME=$(nmcli -t -f type,name c | awk -F: '$1 == "gsm" { print $2 }')
[ -n "$CON_NAME" ] || CON_NAME="$1"
CMD="$2"

CON_RECOVER="connection-recover"
CON_RECOVER_FILE="/etc/runlevels/default/$CON_RECOVER"

if nmcli con show "$CON_NAME" >/dev/null 2>&1; then
	if [ "$CMD" = "up" ]; then
		rc-service "$CON_RECOVER" start
		rc-update add "$CON_RECOVER"
		persist_file "$CON_RECOVER_FILE"
	fi

	if [ "$CMD" = "down" ]; then
		rc-service "$CON_RECOVER" stop
		if rc-update del "$CON_RECOVER" >/dev/null 2>&1; then
			persist_file -d "$CON_RECOVER_FILE" || :
		fi
	fi
	nmcli con "$CMD" "$CON_NAME"
fi
