function close_swu_popup() {
    document.getElementById("swu_progress_overlay").style.visibility = "hidden";
    var close = document.getElementById("swu_progress_close");
    close.classList.add("disabled");
    close.disabled = true;
}

function swu_progress(ev) {
    var prev_offset = ev.target.x_processed_until || 0;
    var offset = ev.loaded;
    ev.target.x_processed_until = offset;
    var box = document.getElementById("swu_progress_text");

    if (prev_offset == 0) {
        box.innerHTML = ""
    }
    var lines = ev.target.response.slice(prev_offset, offset).split('\n');
    for (var i = 0; i < lines.length; i++) {
        // XXX color ERROR etc
        var p = document.createElement("p");
        p.innerText = lines[i];
        box.appendChild(p);
    }
}
function swu_done(ev) {
    document.getElementById("swu_progress_loader").style.visibility = "hidden";

    var close = document.getElementById("swu_progress_close");
    close.classList.remove("disabled");
    close.disabled = false;

    if (ev.target.responseURL.endsWith("/swu_latest_log")) {
        // do not print install status for logs
        return;
    }
    if (ev.target.response == "") {
        // we don't get any response if update failed during upload,
        // fetch latest logs instead...
        swu_install(document.getElementById("swu_post_logs"));
        document.getElementById("swu_progress_status").innerText = "インストールが失敗しました。";
        return;
    }

    var box = document.getElementById("swu_progress_text")

    // success if it output one of the following:
    var success_strs = [
        'swupdate triggering reboot!',
        'swupdate triggering poweroff!',
        'swupdate waiting until external reboot',
        'SWUPDATE successful',
    ];
    var success = false;
    for (var i in success_strs) {
        success ||= box.innerHTML.includes(success_strs[i]);
    }

    var summary = success ? "インストールが成功しました。" : "インストールが失敗しました。";
    document.getElementById("swu_progress_status").innerText = summary;
}

function swu_upload_progress(ev) {
    var box = document.getElementById("swu_progress_text")
    percent = 100 * ev.loaded / ev.total;
    box.innerHTML = '<p>SWU アップロード中... ' + percent.toFixed(2) + '%</p>';
}

function swu_install(form) {
    // URL: set URL to PH value if not set
    if (form.url && ! form.url.value) {
        if (!form.url.placeholder) {
            alert("URL を入力してください。");
            close_swu_popup();
            return;
        }
        form.url.value = form.url.placeholder;
    }
    if (form.file && ! form.file.value) {
        alert("SWU ファイルを選択してください。");
        close_swu_popup();
        return;
    }
    var installing = form.url ? form.url.value : form.file ? form.file.files[0].name : "";
    if (installing) {
        document.getElementById("swu_progress_title").innerText = installing + " をインストールします。";
        document.getElementById("swu_progress_text").innerHTML = form.url ? "実行中…":  "";
    } else {
        document.getElementById("swu_progress_title").innerText = "最新のインストールログ";
        document.getElementById("swu_progress_text").innerHTML = "ログ取得中…";
    }
    document.getElementById("swu_progress_status").innerText = "";
    document.getElementById("swu_progress_loader").style.visibility = "visible";

    const formData = new FormData(form);
    var xhr = new XMLHttpRequest();
    if (form.file) {
        // only makes sense for file upload
        xhr.upload.addEventListener('progress', swu_upload_progress);
    }
    xhr.addEventListener('progress', swu_progress);
    xhr.addEventListener('loadend', swu_done);

    xhr.open(form.method, form.action, true);
    xhr.send(formData);
}

function swu_start_install(ev) {
    ev = ev || windows.event;

    // abort normal post to avoid page reloading
    ev.preventDefault();

    // open popup
    document.getElementById("swu_progress_overlay").style.visibility = "visible";

    // start xhr and feed popup
    swu_install(ev.target);
    return false;
}


document.addEventListener("DOMContentLoaded", function(_ev) {
    var elements = document.getElementsByClassName("swu_post");
    for (var i = 0; i < elements.length; i++) {
        elements[i].addEventListener('submit', swu_start_install);
    }
    document.getElementById("swu_progress_close").addEventListener("click", close_swu_popup);
})
